/*
 * Jabber AIM-Transport libfaim interface
 *
*/

#include "aimtrans.h"

int at_parse_incoming_im(aim_session_t *ass, 
                         aim_frame_t *command, ...)
{
	int channel;
	va_list ap;
    aim_userinfo_t *userinfo;
    at_session s;
    ati ti;
    at_buddy buddy;

    s = (at_session)ass->aux_data;
    ti = s->ti;

	va_start(ap, command);
	channel = va_arg(ap, int);
    userinfo = va_arg(ap, aim_userinfo_t *);

    buddy = xhash_get(s->buddies, userinfo->sn);

	/*
	* Channel 1: Standard Message
	*/
	if (channel == 1)
	{
        struct aim_incomingim_ch1_args *args;
        char *msg;
        char *fullmsg;
        int i;
    	u_int icbmflags = 0;
    	u_short flag1, flag2;
		jpacket jp;
		xmlnode par;
		xmlnode node;
		jid from;
  
        args = va_arg(ap, struct aim_incomingim_ch1_args *);
        va_end(ap);
		
#if 0
        if(args->icbmflags & AIM_IMFLAG_HASICON)
        {
            if(args->iconstamp > buddy->iconstamp)
            {
                // Send the IM to req it?
            }
        }
#endif
		par = xmlnode_new_tag("message");
		xmlnode_put_attrib(par, "type", "chat");
		xmlnode_put_attrib(par, "to", jid_full(s->cur));
		xmlnode_put_attrib(par, "from", ti->i->id);
		jp = jpacket_new(par);
		node = xmlnode_insert_tag(jp->x, "body");
        msg = strip_html(args->msg, jp->p);
		msg = (char *)str_to_UTF8(jp->p, (unsigned char *)msg);
        fullmsg = pmalloco(xmlnode_pool(node), strlen(msg) + 30);
        if(icbmflags & AIM_IMFLAGS_AWAY)
        {
            strcat(fullmsg, "(AutoReply) ");
        }
        strcat(fullmsg, msg);
        if(s->away && (!(icbmflags & AIM_IMFLAGS_AWAY)))
        {
            aim_send_im(ass, userinfo->sn, AIM_IMFLAGS_AWAY, s->status);
            strcat(fullmsg, " (Sent AutoReply)");
        }
		xmlnode_insert_cdata(node, fullmsg, strlen(fullmsg));


		jid_set(jp->from, at_normalize((char *)userinfo->sn), JID_USER);
                xmlnode_put_attrib(jp->x,"from",jid_full(jp->from));

		log_debug(ZONE, "[AIM] Sending: %s\n", xmlnode2str(jp->x));
        deliver(dpacket_new(jp->x), ti->i);

        pth_wait(NULL);
	}
	else if(channel == 2)
	{
		/* XXX decide how to handle groupchat requests */
		/* XXX Actualy parse and use this */
        struct aim_incomingim_ch2_args *args;
    
        args = va_arg(ap, struct aim_incomingim_ch2_args *);
        va_end(ap);

#if 0
        switch (args->reqclass) 
        {
            case AIM_CAPS_BUDDYICON:
                if(buddy->icon != NULL)
                    free(buddy->icon);
                memcpy(buddy->icon, args->info.icon.icon);
                buddy->iconlen = args->info.icon.length;
                break;
        }
#endif
                
	}

  return 1;
}

int at_offlinemsg(aim_session_t *sess,
                  aim_frame_t *command, ...)
{
       va_list ap;
       struct aim_icq_offlinemsg *msg;
       struct gaim_connection *gc = sess->aux_data;
       at_session s;
       ati ti;

       va_start(ap, command);
       msg = va_arg(ap, struct aim_icq_offlinemsg *);
       va_end(ap);

       s = (at_session)sess->aux_data;
       ti = s->ti;

       if (msg->type == 0x0001) {
               xmlnode x;
               xmlnode body;
               jpacket jp;
               char *cmsg;
               char *fmsg;

               x = xmlnode_new_tag("message");
               xmlnode_put_attrib(x, "to", jid_full(s->cur));
               xmlnode_put_attrib(x, "from", jid_full(s->from));

               jp = jpacket_new(x);
               body = xmlnode_insert_tag(jp->x, "body");
               cmsg = strip_html(msg->msg, jp->p);
               cmsg = (char *)str_to_UTF8(jp->p, (unsigned char *)cmsg);
               fmsg = pmalloco(xmlnode_pool(body), strlen(cmsg) + 3);
               strcat(fmsg, cmsg);
               xmlnode_insert_cdata(body, fmsg, strlen(fmsg));

               deliver(dpacket_new(x), ti->i);
       } else {
               log_debug(ZONE, "[AIM] unknown offline message type 0x%04x\n", msg->type);
       }

       return 1;
}

int at_offlinemsgdone(aim_session_t *sess,
                      aim_frame_t *command, ...)
{
       aim_icq_ackofflinemsgs(sess);
       return 1;
}

int at_parse_misses(aim_session_t *sess, 
                    aim_frame_t *command, ...)
{
    xmlnode x;
    xmlnode body;
    at_session s;
    ati ti;

    static char *missedreasons[] = {
        "Unknown",
        "Message too large"};
    static int missedreasonslen = 2;

    va_list ap;
    unsigned short chan, nummissed, reason;
    aim_userinfo_t *userinfo;
    char msg[1024];

    s = (at_session)sess->aux_data;

	x = xmlnode_new_tag("message");
	xmlnode_put_attrib(x, "to", jid_full(s->cur));
	xmlnode_put_attrib(x, "from", jid_full(s->from));
	xmlnode_put_attrib(x, "type","error");
	body = xmlnode_insert_tag(x, "error");
  
    va_start(ap, command);
    chan = va_arg(ap, u_int);
    userinfo = va_arg(ap, aim_userinfo_t *);
    nummissed = va_arg(ap, u_int);
    reason = va_arg(ap, u_int);
    va_end(ap);

    memset(&msg, '\0', 1024);
    snprintf((char *)&msg, 1024, "Missed %d messages from %s (reason %d: %s)", 
             nummissed, userinfo->sn, reason, 
             (reason<missedreasonslen)?missedreasons[reason]:"unknown");
  
    xmlnode_insert_cdata(body, (char *)&msg, strlen((char *)&msg));

    deliver(dpacket_new(x), ti->i);
    return 1;
}

int at_parse_msgerr(aim_session_t *sess, aim_frame_t *command, ...)
{
    xmlnode x;
    xmlnode body;
    jpacket jp;
    at_session s;
    ati ti;
    char msg[1024];

    va_list ap;
    char *destsn;
    unsigned short reason;

    va_start(ap, command);
    reason = va_arg(ap, u_int);
    destsn = va_arg(ap, char *);
    va_end(ap);

    memset((char *)&msg, '\0', 1024);
    snprintf((char *)&msg, 1024, 
             "faimtest: message to %s bounced (reason 0x%04x: %s)\n", 
             destsn, reason, 
             (reason<msgerrreasonslen)?msgerrreasons[reason]:"unknown");

    s = (at_session)sess->aux_data;
    ti = s->ti;

	x = xmlnode_new_tag("message");
	xmlnode_put_attrib(x, "to", jid_full(s->cur));
	xmlnode_put_attrib(x, "from", jid_full(s->from));
	xmlnode_put_attrib(x, "type","error");
	body = xmlnode_insert_tag(x, "error");
    xmlnode_insert_cdata(body, (char *)&msg, strlen((char *)&msg));

    deliver(dpacket_new(x), ti->i);
  
    return 1;
}
